
                                        # AnImAl
#
# R function wrappers for the relational subset of
# aniOp, implementing the history mechanism for
# animage objects
#

ia.and <- function (img1, img2, filter = NULL) {

  res <- aniOp(img1, "&", img2)

  if(is.call(updatedHistory <- ia.updatedHistory(match.call()))) {
    res@history  <- updatedHistory
    res@document <- TRUE
  } else {
    res@history  <- call("<undef>")
    res@document <- FALSE
  }

  return(res)
}

ia.or <- function (img1, img2, filter = NULL) {

  res <- aniOp(img1, "|", img2)

  if(is.call(updatedHistory <- ia.updatedHistory(match.call()))) {
    res@history  <- updatedHistory
    res@document <- TRUE
  } else {
    res@history  <- call("<undef>")
    res@document <- FALSE
  }

  return(res)
}

ia.xor <- function (img1, img2, filter = NULL) {

  res <- aniOp(img1, "^", img2)

  if(is.call(updatedHistory <- ia.updatedHistory(match.call()))) {
    res@history  <- updatedHistory
    res@document <- TRUE
  } else {
    res@history  <- call("<undef>")
    res@document <- FALSE
  }

  return(res)
}

ia.not <- function (img1) {

  res      <- aniOp(img1, "!", .Machine$integer.max)
  
  if(is.call(updatedHistory <- ia.updatedHistory(match.call()))) {
    res@history  <- updatedHistory
    res@document <- TRUE
  } else {
    res@history  <- call("<undef>")
    res@document <- FALSE
  }

  return(res)
}

