# AnImAl
#
#
# R function wrappers for the relational subset of
# aniOp, implementing the history mechanism for
# animage objects
#

ia.greater <- function (img1, img2, filter = NULL) {

  res <- aniOp(img1, ">", img2)

  if(is.call(updatedHistory <- ia.updatedHistory(match.call()))) {
    res@history  <- updatedHistory
    res@document <- TRUE
  } else {
    res@history  <- call("<undef>")
    res@document <- FALSE
  }

  return(res)
}

ia.greater_or_eq <- function (img1, img2, filter = NULL) {

  res <- aniOp(img1, ">=", img2)

  if(is.call(updatedHistory <- ia.updatedHistory(match.call()))) {
    res@history  <- updatedHistory
    res@document <- TRUE
  } else {
    res@history  <- call("<undef>")
    res@document <- FALSE
  }

  return(res)
}

ia.less <- function (img1, img2, filter = NULL) {

  res <- aniOp(img1, "<", img2)

  if(is.call(updatedHistory <- ia.updatedHistory(match.call()))) {
    res@history  <- updatedHistory
    res@document <- TRUE
  } else {
    res@history  <- call("<undef>")
    res@document <- FALSE
  }

  return(res)
}

ia.less_or_eq <- function (img1, img2, filter = NULL) {

  res <- aniOp(img1, "<=", img2)

  if(is.call(updatedHistory <- ia.updatedHistory(match.call()))) {
    res@history  <- updatedHistory
    res@document <- TRUE
  } else {
    res@history  <- call("<undef>")
    res@document <- FALSE
  }

  return(res)
}

ia.equal <- function (img1, img2, filter = NULL) {

  res <- aniOp(img1, "<=", img2)

  if(is.call(updatedHistory <- ia.updatedHistory(match.call()))) {
    res@history  <- updatedHistory
    res@document <- TRUE
  } else {
    res@history  <- call("<undef>")
    res@document <- FALSE
  }

  return(res)
}

ia.min <- function (img1, img2, filter = NULL) {

  res <- aniOp(img1, "MIN", img2)

  if(is.call(updatedHistory <- ia.updatedHistory(match.call()))) {
    res@history  <- updatedHistory
    res@document <- TRUE
  } else {
    res@history  <- call("<undef>")
    res@document <- FALSE
  }

  return(res)
}

ia.max <- function (img1, img2, filter = NULL) {

  res <- aniOp(img1, "MAX", img2)

  if(is.call(updatedHistory <- ia.updatedHistory(match.call()))) {
    res@history  <- updatedHistory
    res@document <- TRUE
  } else {
    res@history  <- call("<undef>")
    res@document <- FALSE
  }

  return(res)
}
