#
# Affine data must be in the following format
#
#
# a11 a12 b1
# a21 a22 b2
#   0   0  1 
#
ia.affine <- function(img,
                      affineMat)
{
  if(!(is.animage(img)) || !(is.array(affineMat)))
    stop("first argument must be an animage, second argument must be an array")

  if(length(dim(affineMat)) != 2)
    stop("affine information  must be 2-dimensional")
  
  if((dim(affineMat)[1] != 3) || (dim(affineMat)[2] != 3))
    stop("affineMat matrix must be 3x3")
  
  if(!(is.real(affineMat)))
    stop("affine transformation matrix must be real")

  if(img@storage == "real") {
    res <- .Call("aniAffineReal",
                 img,
                 affineMat,
                 PACKAGE="AnImAl")
  } else {
    res <- .Call("aniAffineInt",
                 img,
                 affineMat,
                 PACKAGE="AnImAl")
  }
  
  if(is.call(updatedHistory <- ia.updatedHistory(match.call()))) {
    res@history  <- updatedHistory
    res@document <- TRUE
  } else {
    res@history  <- call("<undef>")
    res@document <- FALSE
  }

  res
}
