#
#
#
ia.convolution <- function(img,
                           kernel)
{
  if(!(is.animage(img)) || !(is.array(kernel)))
    stop("first argument must be an animage, second argument must be an array")

  if(length(dim(kernel)) != 2)
    stop("convolution kernel must be 2-dimensional")
  
  if(((dim(kernel)[1] %% 2) != 1) ||
     ((dim(kernel)[2] %% 2) != 1))
    stop("convolution kernel dimensions must be odd")
  
  if((img@storage == "integer") && !(is.integer(kernel)))
    stop("image and kernel must be both integer")

  if((img@storage == "real") && !(is.real(kernel)))
    stop("image and kernel must be both real")

  if(img@storage == "real") {
    res <- .Call("aniConvolutionReal",
                 img,
                 kernel,
                 PACKAGE="AnImAl")
  } else {
    res <- .Call("aniConvolution",
                 img,
                 kernel,
                 PACKAGE="AnImAl")
  }
  
  if(is.call(updatedHistory <- ia.updatedHistory(match.call()))) {
    res@history  <- updatedHistory
    res@document <- TRUE
  } else {
    res@history  <- call("<undef>")
    res@document <- FALSE
  }

  res
}
