ia.eps <- function(img,
                   file,
                   srcRange = c(0, 255),
                   dstRange = c(0.05,0.95),
                   stretch  = FALSE,
                   gamma    = 1.0,
                   color    = FALSE,
                   channels = c(1,2,3),
                   weights  = c(1,1,1)) {

  if(color) {
    postscript(file       = file,
               width      = dim(img[[1]]@data)[2] / 300.0,
               height     = dim(img[[1]]@data)[1] / 300.0,
               horizontal = FALSE,
               onefile    = FALSE,
               paper      = "special")
    
    par(mar=c(0,0,0,0))
  
    plot(pixmapRGB(abind(img[[1]]@data,
                         img[[2]]@data,
                         img[[3]]@data, rev.along=0)))

    dev.off()    
  } else {
    if(is.list(img)) {
      img <- ia.averageImageChannels(img, channels, weights)
    }

    if(stretch) {
      img <- ia.stretchRange(ia.realAnimage(img), dstRange)
    } else {
      img <- ia.mapRange(ia.realAnimage(img), srcRange, dstRange)
    }

    if(gamma != 1.0) {
      img@data <- img@data^gamma
    }

    postscript(file       = file,
               width      = dim(img@data)[2] / 300.0,
               height     = dim(img@data)[1] / 300.0,
               horizontal = FALSE,
               onefile    = FALSE,
               paper      = "special",
               colormodel = "gray")
    
    par(mar=c(0,0,0,0))
    
    plot(pixmapGrey(img@data))
    
    dev.off()
  }
  
  TRUE
}

