\name{animask-class}
\docType{class}
\alias{animask-class}
\alias{animask}
\alias{as.animask}
\alias{as.animask,integer-method}
\alias{as.animask,list-method}
\alias{show,animask-method}
\alias{print.animask}
\alias{is.animask}


\title{Class "animask"}

\description{ A simple structure to represent regions of interest within
  \code{animage} objects to focus computations}

\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("animask", ...)}.
The resulting objects can be passed to many \code{ia.} operations to
focus computation.

\code{animask} is the preferred constructor

\code{as.animask(x)}, generic, coerces a vector or  a list of length 2 or 4
to a  mask. The values are  matched to the  arguments of \code{animage},
eventually defaulting \code{x,y} to \code{0}.

\code{is.animask(x)} returns \code{TRUE} if \code{x} is an \code{animask}

}

\section{Slots}{
	 \describe{
    \item{\code{x}:}{Object of class \code{"integer"} represents the
	  column index of the upper left corner of the region}
    \item{\code{y}:}{Object of class \code{"integer"} represents the row
	index of the upper left corner of the region}
    \item{\code{w}:}{Object of class \code{"integer"} represents the
	  width of the region}
    \item{\code{h}:}{Object of class \code{"integer"} represents the
	  height of the region }
  }
}

\usage{
animask(x, y, w, h)
}

\arguments{
  \item{x}{see class slots}
  \item{y}{''}
  \item{w}{''}
  \item{h}{''}
}

\author{Roberto Brunelli \email{brunelli@fbk.eu}}

\seealso{
	\code{\linkS4class{animage}}, \link{aniUtilities}
}
\examples{
#
showClass("animask")
#
# create an animage
#
img1 <- animage(array(c(1,2,3,
                        1,1,1,
                        8,8,8), c(3,3)),
                focus = c(1,1),
                document = TRUE)
#
# and print the corresponding mask
#
ia.mask(img1)
}
\keyword{classes}
