\name{ia.average}

\alias{ia.average}

\title{Image smoothing by linear averaging}

\description{

   Smooth an  integer (real) \code{animage} with a flat rectangular kernel

}

\usage{ia.average(img, widthx, widthy, norm = TRUE)}

\arguments{
   	\item{img}{an integer (real) \code{animage}}
	\item{widthx}{an integer representing the width of the averaging
	  window}
	\item{widthy}{an integer representing the height of the averaging
	  window}
	\item{norm}{an integer, 0L if normalization is required}
}

\value{
 An \code{animage}.
}

\details{
  
  The  function  convolves the given \code{animage}
  with a rectangular (flat) kernel in an efficient way so that the
  computation scales with the linear dimension of the averaging window
  and not with its area.

}

\author{Roberto Brunelli \email{brunelli@fbk.eu}}

\examples{
#
# get paths to package samples
#
sampleimages <- file.path(system.file(package = "AnImAl"), "sampleimages")
#
# Read a sample image
#
sampleFace <- as.animage(getChannels(read.pnm(file.path(sampleimages,
"sampleFace_01.pgm"))))
#
# smooth it
#
smoothedSampleFace <- ia.average(sampleFace, 22L, 22L)
#
# have a look
#
ia.show(smoothedSampleFace)
}
\keyword{array}
