\name{ia.moravec}

\alias{ia.moravec}

\title{Moravec interest operator}

\description{

  Detect structurally interesting image points

}

\usage{ia.moravec(img, width = 3L)}

\arguments{
   	\item{img}{an integer (real) \code{animage}}
	\item{width}{an integer representing the width of the integratioon window}
}

\value{
 An \code{animage}.
}

\details{

  The function \code{ia.moravec} computes for each image point an
  interest score, defined as the minimum (intensity of the) difference
  over a set of four directions. Typical applications include corner
  detection and selection of image features that can be reliably tracked
  over subsequent frames.

}

\author{Roberto Brunelli \email{brunelli@fbk.eu}}

\examples{
#
# get paths to package samples
#
sampleimages <- file.path(system.file(package = "AnImAl"), "sampleimages")
#
# Read a sample image
#
sampleFace <- as.animage(getChannels(read.pnm(file.path(sampleimages,
"sampleFace_01.pgm"))))
#
# compute an 'interest map'
#
moravecMap <- ia.moravec(sampleFace, width = 5L)
#
# and have a look at its inverted version:
#
# the darker the more interesting the point
#
ia.show(ia.mult(moravecMap, -1), xlab="Moravec interest map")
#
}
\keyword{array}
