\name{ia.table}

\alias{ia.table}
\alias{ia.tableR}

\title{Trasform animage values by table lookup}

\description{

   Transform  an \code{animage}  mapping  its scalar  pixels into  new
values  obtained  by table  look  up.   The  operation is  very  fast,
substituting   computation   with   memory.   A   companion   function
(\code{ia.tableR}) is provided  to compare C and R  speed (C turns out
to be ~40x faster than R).

}

\usage{
ia.table(img, table, tableOffset)
ia.tableR(img, table, tableOffset)
}

\arguments{
   \item{img}{an animage object}
   \item{table}{an integer vector}
   \item{tableOffset}{the 'index' of the first table element}
}

\value{
 A new \code{animage} whose values are computed by table lookup.
}

\author{Roberto Brunelli \email{brunelli@fbk.eu}}

\seealso{
   \link{aniOp}, \code{\link{ia.cam}}
}

\examples{
#
# get paths to package samples
#
sampleimages <- file.path(system.file(package = "AnImAl"), "sampleimages")
#
# Read the second channel of a TIFF file
#
sampleFace <- ia.readAnimageChannel(file.path(sampleimages, "sampleFace_06.tif"), 2)
#
# invert it, 
#
invertedSampleFace <- ia.table(as.animage(sampleFace), 255:0, 0L)
#
# and visualize it using the facilities of the pixmap
# package
#
ia.show(invertedSampleFace)
#
}
\keyword{array}
