/*
 * (c) 1993,1994,1995,1996 by ITC-IRST
 *
 */

#ifndef AVERAGE_H 
#define AVERAGE_H 

#include <arrayTools/Array.h>

#include <arrayTools/namespace_header.h>


namespace _ARRAYTOOLS_NAMESPACE
{

template<class T> array<T>&
Average(array<T>& I, int wx, int wy, bool normalize = true)
 {
   array<T> *R;
   int	     wxh = wx/2, wyh = wy/2;
   int	     rr, cc;
   double    s, ss;
   int	     n, Y, l, r, ns;
   int	     x, y, i, j;
   int       x0, x1, y0, y1;
   int       base_x, base_y;
   T       **_I, **_R;
   
   base_x = I.first_col_index();
   base_y = I.first_row_index();
   
   
   I.translate_at(0,0);
   
   x0 = I.first_col_index();
   x1 = I.last_col_index();
   y0 = I.first_row_index();
   y1 = I.last_row_index();
   
   rr = I.rows();
   cc = I.cols();
   
   R 		= new array<T>(y0, y1, x0, x1);
   wxh		= MIN(wxh, cc);
   wyh		= MIN(wyh, rr);
   
   ss	= 0;
   ns 	= 0;
	
   _I   = I.storage();
   _R   = (*R).storage();
   
   for(j = -wyh; j <= wyh; j++)
      {
	for(i = 0; i <= wxh; i++)
	   {
	     if((j >= 0) && (j < rr))
		{
		  ns++;
		  ss += _I[j][i];
		}
	   }
      }

   for(y = 0; y < rr; y++)
      {
	s = ss;
	n = ns;
	l = -wxh;
	r =  wxh+1;
   
	_R[y][0] = (T)(s/n);
	
	for(x = 1; x < cc; x++)
	   {
	     for(j = -wyh; j <= wyh; j++)
		{
		  Y = y+j;
		  if((Y >= 0)  && (Y < rr))
		     {
		       if(l >= 0)
			  {	
			    s -= _I[Y][l];
			    n--;
			  }
		       if(r < cc)
			  {
			    s += _I[Y][r];
			    n++;
			  }
		     }
		}

	     if(normalize)
	       _R[y][x] = (T) (s/n);
	     else
	       _R[y][x] = (T) (s);

	     l++;
	     r++;
	   }

	//! Adjust for moving down 
	//!
	Y = y - wyh;
	if(Y >= 0)
	   {
	     for(i = 0; i <= wxh; i++)
		{
		  ns--;
		  ss -= _I[Y][i];
		}
	   }
	Y = y + wyh + 1;
	if(Y < rr)
	   {
	     for(i = 0; i <= wxh; i++)
		{
		  ns++;
		  ss += _I[Y][i];
		}
	   }
      }
   
   (*R).translate_at(base_y, base_x);

   DeleteIfTemporary(I);
   return((*R).temporary());
 }


}



#endif
