#ifndef PPMIO_H
#define PPMIO_H

/*
 * Define PGM and PPM, i.e. gray images and color images.
 */

#include <arrayTools/Array.h>
#include <arrayTools/namespace_header.h>


namespace _ARRAYTOOLS_NAMESPACE
{

  int ReadPPMFileHeader(istream& f,
			int & width, 
			int & height, 
			int & maxIntensity);
  const char * ReadPPMFileHeader(const char * input,
				 int & width, 
				 int & height, 
				 int & maxIntensity,
				 int & type);


  //return status TRUE or FALSE
  
  //===================================
  //READ

  int ReadPpm(array<unsigned char>& R, 
	      array<unsigned char>& G,
	      array<unsigned char>& B,
	      istream&       s);

  int ReadPgm(array<unsigned char>& I, 
	      istream&       s);

  int ReadPbm(array<unsigned char>& I, 
	      istream&       s,
	      int foreground_value = 0, 
	      int background_value = 1);

  int ReadPpm(array<unsigned char>& R, 
	      array<unsigned char>& G,
	      array<unsigned char>& B,
	      const char * filename);

  int ReadPgm(array<unsigned char>& I, 
	      const char * filename);

  int ReadPbm(array<unsigned char>& I, 
	      const char * filename,
	      int foreground_value = 0, 
	      int background_value = 1);

  int ReadPpm(array<unsigned char>& R, 
	      array<unsigned char>& G,
	      array<unsigned char>& B,
	      const char * input, 
	      int len);     

  int ReadPgm(array<unsigned char>& I, 
	      const char * input,
	      int len);


  //===================================
  //WRITE


  int WritePpm(array<unsigned char>& R, 
	       array<unsigned char>& G,
	       array<unsigned char>& B,
	       ostream&       s);

  int WritePgm(array<unsigned char>& I, 
	       ostream&       s);


  int WritePpm(array<unsigned char>& R, 
	       array<unsigned char>& G,
	       array<unsigned char>& B,
	       const char * filename);

  int WritePgm(array<unsigned char>& I, 
	       const char * filename);


  int WritePbm(array<unsigned char> & I,
	       ostream & s);

  int WritePbm(array<unsigned char> & I,
	       const char * filename);



}


#endif
