#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include <arrayTools/aniCommon.h>

extern "C"  {

  SEXP aniGaussianR(SEXP animage_1, // Must be an animage object
					SEXP r_sigma)   // must be a real 
  {
	// Get info on the kernel
	//
	double sigma   = (REAL(r_sigma))[0];

	ia::array<double> A = r2ia_rd(animage_1);

	A = GaussianSmooth(A, sigma);
	
	return(ia2r_dr(A));
  }

  SEXP aniGaussianI(SEXP animage_1, // Must be an animage object
					SEXP r_sigma)   // must be a real 
  {
	// Get info on the kernel
	//
	double sigma   = (REAL(r_sigma))[0];

	ia::array<int> A = r2ia_ii(animage_1);

	A = GaussianSmooth(A, sigma);
	
	return(ia2r_ii(A));
  }
}
